/*  QMC: simplification tool (by using the Quine - McClusky process)
    Copyright (C) 2000  Thomas Pollak

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  

Auf Deutsch:

    QMC: Vereinfachungsprogramm fuer logische Terme nach Quine - McClusky
    Copyright (C) 2000  Thomas Pollak

    Dieses Programm ist freie Software. Sie knnen es unter
    den Bedingungen der GNU General Public License, wie von der
    Free Software Foundation herausgegeben, weitergeben und/oder
    modifizieren, entweder unter Version 2 der Lizenz oder
    jeder spaeteren Version.

    Die Veroeffentlichung dieses Programms erfolgt in der
    Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE
    GEWAEHRLEISTUNG - sogar ohne die implizite Gewaehrleistung
    der MARKTREIFE oder der EIGNUNG FUER EINEN BESTIMMTEN ZWECK.
    Details finden Sie in der GNU General Public License.

    Sie sollten eine Kopie der GNU General Public License zusammen
    mit diesem Programm erhalten haben. Falls nicht, schreiben Sie
    an die Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
    MA 02139, USA.
*/

//Headers
#include <cqmc>
#include <iostream>

//Debug - switch
//#define DEBUG

using namespace std;

/*****************************************************************
 *                                                               *
 * eliminate values, which are existing more often than one time *
 *                                                               *
 *****************************************************************/

void *daus(BOOL *lh, char anz, unsigned short &high, bool p)
{
  BOOL *newlh;
  unsigned short i,j, nhigh=0;
  unsigned char h, abweichung;
  bool check[high];

  //Status
  if(p) cout << '.' << flush;

  for(i=0;i<high;i++)
  {
    check[i]=0;
  }

  #ifdef DEBUG

    cerr << endl << "DAUS Check";

    for(i=0;i<high*anz;i++)
    {
      if((i+anz)%anz==0 )
      {
        cerr << endl << "    " << i/anz << '.';
      }

      cerr << "[" << lh[i].getid() << lh[i].value() << ']';
    }

    cerr << endl << "    finished!" << endl;
    
  #endif


  for(i=0;i<high;i++)
  {
    for(j=i+1;j<high;j++)
    {
      if(check[j]!=1)
      {
        abweichung=0;

        #ifdef DEBUG
          cerr << endl << "DAUS: compare: " << j << ' ' << i << " of " << high;
        #endif

        for(h=0;h<anz;h++)
        {
          if(lh[i*anz+h].getid()==lh[j*anz+h].getid())
          {
            if(lh[i*anz+h].getid()=='-')
            {
              abweichung++;
            }
            else if(lh[i*anz+h].value()==lh[j*anz+h].value())
            {
              abweichung++;
            }
          }

          #ifdef DEBUG
            cerr << " [" << lh[i*anz+h].value() << lh[i*anz+h].getid() << lh[j*anz+h].value() << lh[j*anz+h].getid() << ']';
          #endif
        }

        if(abweichung==anz)
        {
          check[i]=1;

          #ifdef DEBUG
            cerr << "\n\nDAUS: equal element found!" << i << endl;
          #endif

        }

      }

      //Status
      if(p) cout << '.' << flush;

    }
  }

  for(i=0;i<high;i++)
  {
    if(check[i])
    {
      nhigh++;
    }
  }

  #ifdef DEBUG
    cerr << "\n\nDAUS: number of new terms: " << nhigh << "  creating objects.." << endl;
  #endif

  newlh = new BOOL[anz*(high-nhigh)];

  j=0;

  #ifdef DEBUG
    cerr << endl << "DAUS:";
  #endif

  for(i=0;i<high;i++)
  {
    if(check[i]==0)
    {
      #ifdef DEBUG
        cerr << "\n    act.:" << j << " with:" << i;
      #endif

      for(h=0;h<anz;h++)
      {
        newlh[j*anz+h].setvalue(lh[i*anz+h].value());
        newlh[j*anz+h].setid(lh[i*anz+h].getid());

        #ifdef DEBUG
          cerr << "[" << newlh[j*anz+h].value() << newlh[j*anz+h].getid() << ']';
        #endif

      }

      j++;
    }
  }

  //Status
  if(p) cout << '.' << flush;

  #ifdef DEBUG
    cerr << "\nDAUS: high:" << high << " newhigh:" << nhigh;
  #endif

  high-=nhigh;

  return((void *)newlh);
}
