/*  QMC: simplification tool (by using the Quine - McClusky process)
    Copyright (C) 2000  Thomas Pollak

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  

Auf Deutsch:

    QMC: Vereinfachungsprogramm fuer logische Terme nach Quine - McClusky
    Copyright (C) 2000  Thomas Pollak

    Dieses Programm ist freie Software. Sie knnen es unter
    den Bedingungen der GNU General Public License, wie von der
    Free Software Foundation herausgegeben, weitergeben und/oder
    modifizieren, entweder unter Version 2 der Lizenz oder
    jeder spaeteren Version.

    Die Veroeffentlichung dieses Programms erfolgt in der
    Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE
    GEWHRLEISTUNG - sogar ohne die implizite Gewaehrleistung
    der MARKTREIFE oder der EIGNUNG FUER EINEN BESTIMMTEN ZWECK.
    Details finden Sie in der GNU General Public License.

    Sie sollten eine Kopie der GNU General Public License zusammen
    mit diesem Programm erhalten haben. Falls nicht, schreiben Sie
    an die Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
    MA 02139, USA.
*/

//Headrs
#include <cqmc>
#include <iostream>
#include <cstring>

using namespace std;

/************************
 *                      *
 * Parameterberprfung *
 *                      *
 ************************/
unsigned char param(char *par)
{
  if(!strcmp(par,"--version"))
  {
    cout << "QMC: simplification tool (by using the Quine - McClusky process)" <<endl;
    cout << "Copyright (C) 2000  Thomas Pollak" << endl << endl;

    cout << "This program is free software; you can redistribute it and/or" << endl;
    cout << "modify it under the terms of the GNU General Public License as" << endl;
    cout << "published by the Free Software Foundation; either version 2 of" << endl;
    cout << "the License, or any later version." << endl << endl;

    cout << "This program is distributed in the hope that it will be useful," << endl;
    cout << "but WITHOUT ANY WARRANTY; without even the implied warranty of" << endl;
    cout << "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU" << endl;
    cout << "General Public License for more details." << endl << endl;

    cout << "You should have received a copy of the GNU General Public License" << endl;
    cout << "along with this program; if not, write to the Free Software" << endl;
    cout << "Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA." << endl << endl;
    
    cout << "Web:             " << QMC_URL << endl;
    cout << "Version:         " << QMC_VERSION << endl;
    cout << "Last update:     " << QMC_DATE << endl;

    return(0);
  }
  else if( !strcmp(par,"-s") || !strcmp(par,"--source") )
  {
    return(1);
  }
  else if( !strcmp(par,"-v") || !strcmp(par,"--verbose") )
  {
    return(2);
  }
  else if( !strcmp(par,"-t") || !strcmp(par,"--table") )
  {
    return(3);
  }
  else if( !strcmp(par,"-g") || !strcmp(par,"--gettable") )
  {
    return(4);
  }
  else if( !strcmp(par,"-G") || !strcmp(par,"--gethtmltable") )
  {
    return(5);
  }
  else if( !strcmp(par,"-p") || !strcmp(par,"--prompt") )
  {
    return(6);
  }
  else if(!strcmp(par,"-h") || !strcmp(par,"--help"))
  {
    cout << "Usage: qmc [OPTION]" << endl;
    cout << "Simplification tool by using the Quine - McClusky process." << endl << endl;

    cout << "  -g, --gettable       get boolean table" << endl;
    cout << "  -G  --gethtmltable   get boolean table as HTML output" << endl;
    cout << "  -h, --help           display this help and exit" << endl;
    cout << "  -p, --prompt         prompt for equation" << endl;
    cout << "  -s, --source EQU     set one side of the equation" << endl;
    cout << "  -t, --table          set boolean table" << endl;
    cout << "  -v, --verbose        print progress" << endl;
    cout << "      --version        output version information and exit" << endl << endl;
    
    cout << "Please report bugs to <thomas@pollaknet.at>." << endl << flush;

    return(0);
  }
  else
  {

    cout << "qmc: too few arguments\nTry `qmc --help' for more information." << endl << flush;

    return(0);
  }
}


