/*  QMC: simplification tool (by using the Quine - McClusky process)
    Copyright (C) 2000  Thomas Pollak

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  

Auf Deutsch:

    QMC: Vereinfachungsprogramm fuer logische Terme nach Quine - McClusky
    Copyright (C) 2000  Thomas Pollak

    Dieses Programm ist freie Software. Sie koennen es unter
    den Bedingungen der GNU General Public License, wie von der
    Free Software Foundation herausgegeben, weitergeben und/oder
    modifizieren, entweder unter Version 2 der Lizenz oder
    jeder spaeteren Version.

    Die Veroeffentlichung dieses Programms erfolgt in der
    Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE
    GEWAEHRLEISTUNG - sogar ohne die implizite Gewaehrleistung
    der MARKTREIFE oder der EIGNUNG FUER EINEN BESTIMMTEN ZWECK.
    Details finden Sie in der GNU General Public License.

    Sie sollten eine Kopie der GNU General Public License zusammen
    mit diesem Programm erhalten haben. Falls nicht, schreiben Sie
    an die Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
    MA 02139, USA.
*/

//Headers
#include <cqmc>
#include <iostream>

using namespace std;

//Debug - switch
//#define DEBUG

/***********
 *         *
 * compare *
 *         *
 ***********/
                   /**** kleinere Bugs ****/
void *vergleichen(BOOL *lh, BOOL *newlh, unsigned char anz, unsigned short &high, bool p)
{
  //objects
  BOOL *temp=0x00, *swap=0x00;

  //local variables
  bool check[high], fehler=0;
  unsigned char index, aindex, abweichung, h;
  unsigned short i, j, ready=0, t;


  #ifdef DEBUG

    cerr << endl << endl << "VERGL. starting function" << endl;
    cerr << "VERGL. number of variables: " << anz << " high: " << high;
    cerr << endl << "VERGL. test:" << endl << endl;

    for(i=0;i<high;i++)
    {
      cerr << i << ". ";

      for(h=0;h<anz;h++)
        cerr << lh[i*anz+h].getid() << lh[i*anz+h].value();

      cerr << endl;
    }

    cerr << endl << endl << "finished! (first element-group)" << endl << endl << "  test check: ";

  #endif


  //Status
  if(p) cout << '.' << flush;


  //creating test-variables
  //check = new bool[high];

  for(i=0;i<high;i++)
  {
    check[i]=0;

    #ifdef DEBUG
      cerr << '|' << check[i];
    #endif
  }

  #ifdef DEBUG
    cerr << "| finished!" << endl << endl << "VERGL. high=" << high << "creating objects...";
  #endif

  //for(t=0;t<anz;t++)
  newlh = new BOOL[anz];

  #ifdef DEBUG
    cerr << " finished!";
  #endif


  //compare evry term
  for(i=0;i<high;i++)
  {
    #ifdef DEBUG
      cerr << endl;
    #endif

    for(j=i+1;j<high;j++)
    {
      abweichung=0;

      for(index=0;index<anz;index++)
      {
        if((lh[ i * anz + index ].getid()=='#')&&(lh[ j * anz + index ].getid()=='#'))
        {
          if(lh[ i * anz + index ].value()!=lh[ j * anz + index ].value())
          {
            abweichung++;
            aindex = index;
          }
        }
        else if((lh[ i * anz + index ].getid()=='-')&&(lh[ j * anz + index ].getid()=='-'))
        {

        }
        else
        {
          abweichung=2;
        }
      }

      if( abweichung == 1 )
      {
        #ifdef DEBUG
          cerr << "\n    VERGL. equal values [" << i << ',' << j;
          cerr << "] - r:" << ready << " Index:" << aindex << " von " << anz << endl;
          cerr << "    VERGL. T1:T2   check: " << check[i] << '|' << check[j] << "   { ";
        #endif


        for(h=0;h<anz;h++)
        {

          newlh[ ready * anz + h ].setvalue(lh[ j * anz + h ].value());
          newlh[ ready * anz + h ].setid(lh[ j * anz + h ].getid());

          #ifdef DEBUG
            cerr << lh[j*anz+h].getid() << newlh[ready*anz+h].getid();
            cerr << lh[j*anz+h].value() << newlh[ready*anz+h].value();
          #endif

          if(lh[j*anz+h].getid()!='#'&&lh[j*anz+h].getid()!='-')  fehler=1;

        }

        #ifdef DEBUG
          cerr << '}' <<endl;
          cerr << "\n   Test:[" << newlh[ready*anz].getid() << newlh[ready*anz].value() << ']';
          cerr << "\n   Test auf Abweichindex:[";
          cerr << newlh[ready*anz+aindex].getid() << newlh[ready*anz+aindex].value() << "]\n\n    Vorher1: ";

          for(t=0;t<anz;t++)
          {
            cerr << '[' << newlh[anz*ready+t].getid() << newlh[anz*ready+t].value() << ']';
          }

        #endif

        newlh[ready*anz+aindex].setid('-');

        #ifdef DEBUG

          cerr << "\n\n    Vorher2: ";

          for(t=0;t<anz;t++)
          {
            cerr << '[' << newlh[anz*ready+t].getid() << newlh[anz*ready+t].value() << ']';
          }

        #endif

        check[i]=1;
        check[j]=1;

        #ifdef DEBUG

          cerr << "\n\n    Vorher3: ";

          for(t=0;t<anz;t++)
          {
            cerr << '[' << newlh[anz*ready+t].getid() << newlh[anz*ready+t].value() << ']';
          }

        #endif

        ready++;

        #ifdef DEBUG
          cerr << endl << "  check:   " << check[i] << '|' << check[j] << "   creating new object array..." << endl << endl << "    before: ";
        #endif

        for(t=0;t<anz;t++)
        {
          newlh[ready*anz+t] = new BOOL;

          #ifdef DEBUG
            cerr << '[' << newlh[anz*(ready-1)+t].getid() << newlh[anz*(ready-1)+t].value() << ']';
          #endif
        }

        //Status
        if(p) cout << '.' << flush;
      }
    }

    #ifdef DEBUG
      cerr << "    test 1: [" << lh[i].getid() << lh[i].value() << ']' << endl;
    #endif

  }

  if(fehler)
  {
    #ifdef DEBUG
      cerr << "\n*** VERGL. Fehler! - Identitt fehlerhaft: " << lh[j*anz+h].getid();
      cerr << " Durchlauf: i:" << i << " j:" << j << " von high:" << high << " ***" << endl;
    #endif

    errormsg("Programmerror in Modul vergl.cc",5);

    //delete [] check;
    //delete [] newlh;
    //delete [] swap;

    return((void *)0x00);
  }

  //jump back if there is no twice existing term (only one layer)
  if(ready==0)
  {
    #ifdef DEBUG
      cerr << "\nVERGL. stop the function - work is done!!";
    #endif

    //delete [] check;
    //delete [] newlh;

    swap=lh;

    //Status
    if(p) cout << '.' << flush;

    lh=(BOOL *)daus(lh,anz,high,p);

    //delete [] swap;

    return((void *)lh);
  }


  #ifdef DEBUG

    cerr << "\nVERGL. (v.V)Ready: " << ready << endl;
    cerr << "\n\n    test 2:" << endl;

    for(i=0;i<ready*anz;i++)
    {
      if((i+anz)%anz==0 )
      {
        cerr << endl << i/anz << ".   ";
      }

      cerr << '[' << newlh[i].getid() << newlh[i].value() << ']';
    }

    cerr << endl << "    finished!" << endl;
  #endif

  //Status
  if(p) cout << '.' << flush;

  //Auf unvernderte Terme berprfen
  for(i=0;i<high;i++)
  {
    if(check[i]==0)
    {
      for(h=0;h<anz;h++)
      {
        newlh[ready*anz+h].setvalue(lh[i*anz+h].value());
        newlh[ready*anz+h].setid(lh[i*anz+h].getid());
      }

      ready++;

      for(t=anz*ready;t<anz*(ready+1);t++)
      {
        newlh[t] = new BOOL;
      }
    }

  }

  temp = new BOOL[ready*anz];

  for(i=0;i<ready*anz;i++)
  {
    temp[i].setid(newlh[i].getid());
    temp[i].setvalue(newlh[i].value());

    #ifdef DEBUG

      if((i+anz)%anz==0 )
      {
        cerr << endl << i/anz << ".   ";
      }

      cerr << '[' << newlh[i].getid() << newlh[i].value() << " <-> ";
      cerr << temp[i].getid() << temp[i].value() << ']';

    #endif

  }

  //Status
  if(p) cout << '.' << flush;

  //Felder freigeben
  //delete [] check;
  //delete [] lh;
  //delete [] newlh;

  #ifdef DEBUG
    cerr << endl << "VERGL. call function once again...";
  #endif

  high=ready;

  swap=temp;

  //Status
  if(p) cout << '.' << flush;

  temp=(BOOL *)daus(temp,anz,high,p);

  //Status
  if(p) cout << '.' << flush;

  //delete [] swap;

  //call the function once again
  return(vergleichen(temp,lh,anz,high,p));
}
